#include <stdio.h>
#include <motelib/system.h>
#include <motelib/uart.h>
#include <motelib/radio.h>
#include <motelib/timer.h>
uint8_t state=NULL;
Timer t,t2;
uint8_t cnt = 0;
void alarm();
void alarm_off();
void fired(Timer *t);
uint8_t far1_1,far2_1,far1_2,far2_2;
void receive(Address src, MessageType type, void *msg, uint8_t len)
{
    	RadioRxStatus rxStat;
	radioGetRxStatus(&rxStat);
	//printf("wait2\n");    
	if (type == 0x01)
    	{
		printf("child1 rssi=%d \r\n",rxStat.rssi);
		
		if(rxStat.rssi>=0 && rxStat.rssi<25)
		{
			far2_1++;	
			if(far2_1>=3){
				timerStop(&t);
				timerStart(&t,TIMER_PERIODIC,200,fired);
				ledSet(1,1);
			}	
		}
		else if(rxStat.rssi>=25 && rxStat.rssi<45)
		{
			ledSet(1,0);
			far2_1=0;
			far1_1++;
			if(far1_1>=3){
				timerStop(&t);
				timerStart(&t,TIMER_PERIODIC,1000,fired);
			}
			
		}
		else if(rxStat.rssi>=45)
		{
			ledSet(1,0);
			ledSet(0,0);
			timerStop(&t);
			far1_1=0;
			far2_1=0;	
			
		}
		
		
		
 	//printf("wait3\n");  
	//radioRequestTx(src,0x02,&state,0,NULL);	    
	}

	if (type == 0x02)
    	{
		printf("child2 rssi=%d \r\n",rxStat.rssi);
		
		if(rxStat.rssi>=0 && rxStat.rssi<25)
		{
			far2_2++;	
			if(far2_2>=3){
				timerStop(&t2);
				timerStart(&t2,TIMER_PERIODIC,200,fired);
				ledSet(2,1);
			}	
		}
		else if(rxStat.rssi>=25 && rxStat.rssi<45)
		{
			ledSet(2,0);
			far2_2=0;
			far1_2++;
			if(far1_2>=3){
				timerStop(&t2);
				timerStart(&t2,TIMER_PERIODIC,1000,fired);
			}
			
		}
		else if(rxStat.rssi>=45)
		{
			ledSet(2,0);
			ledSet(0,0);
			timerStop(&t2);
			far1_2=0;
			far2_2=0;	
			
		}
		
		
		
 	//printf("wait3\n");  
	//radioRequestTx(src,0x02,&state,0,NULL);	    
	}
}


void fired(Timer *t)
{
	ledToggle(0);
}



void boot()
{
    timerCreate(&t);
    timerCreate(&t2);
    uartEnable(true, true);
    radioSetRxHandler(receive);
	//timerCreate(&t);
	//timerStart(&t,TIMER_PERIODIC,1000,sense);
}

